# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosflight_msgs/GNSS.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import std_msgs.msg

class GNSS(genpy.Message):
  _md5sum = "90304417884454ac78807c26357846bc"
  _type = "rosflight_msgs/GNSS"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header # Estimated ROS time at moment of measurement
uint8 fix # fix type, as defined in the UBX protocol, enums defined below
time time # GPS time at moment of measurement
float64[3] position # m, ECEF frame
float64 horizontal_accuracy # m
float64 vertical_accuracy # m
float64[3] velocity # m/s, ECEF frame
float64 speed_accuracy # m/s

uint8 FIX_TYPE_NO_FIX = 0 
uint8 FIX_TYPE_DEAD_RECKONING = 1
uint8 FIX_TYPE_2D = 2
uint8 FIX_TYPE_3D = 3 
uint8 FIX_TYPE_GPS_AND_DEAD_RECKONING = 4
uint8 FIX_TYPE_TIME_ONLY = 5

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  # Pseudo-constants
  FIX_TYPE_NO_FIX = 0
  FIX_TYPE_DEAD_RECKONING = 1
  FIX_TYPE_2D = 2
  FIX_TYPE_3D = 3
  FIX_TYPE_GPS_AND_DEAD_RECKONING = 4
  FIX_TYPE_TIME_ONLY = 5

  __slots__ = ['header','fix','time','position','horizontal_accuracy','vertical_accuracy','velocity','speed_accuracy']
  _slot_types = ['std_msgs/Header','uint8','time','float64[3]','float64','float64','float64[3]','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,fix,time,position,horizontal_accuracy,vertical_accuracy,velocity,speed_accuracy

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GNSS, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.fix is None:
        self.fix = 0
      if self.time is None:
        self.time = genpy.Time()
      if self.position is None:
        self.position = [0.] * 3
      if self.horizontal_accuracy is None:
        self.horizontal_accuracy = 0.
      if self.vertical_accuracy is None:
        self.vertical_accuracy = 0.
      if self.velocity is None:
        self.velocity = [0.] * 3
      if self.speed_accuracy is None:
        self.speed_accuracy = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.fix = 0
      self.time = genpy.Time()
      self.position = [0.] * 3
      self.horizontal_accuracy = 0.
      self.vertical_accuracy = 0.
      self.velocity = [0.] * 3
      self.speed_accuracy = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.fix, _x.time.secs, _x.time.nsecs))
      buff.write(_get_struct_3d().pack(*self.position))
      _x = self
      buff.write(_get_struct_2d().pack(_x.horizontal_accuracy, _x.vertical_accuracy))
      buff.write(_get_struct_3d().pack(*self.velocity))
      _x = self.speed_accuracy
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time is None:
        self.time = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.fix, _x.time.secs, _x.time.nsecs,) = _get_struct_B2I().unpack(str[start:end])
      start = end
      end += 24
      self.position = _get_struct_3d().unpack(str[start:end])
      _x = self
      start = end
      end += 16
      (_x.horizontal_accuracy, _x.vertical_accuracy,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 24
      self.velocity = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 8
      (self.speed_accuracy,) = _get_struct_d().unpack(str[start:end])
      self.time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.fix, _x.time.secs, _x.time.nsecs))
      buff.write(self.position.tostring())
      _x = self
      buff.write(_get_struct_2d().pack(_x.horizontal_accuracy, _x.vertical_accuracy))
      buff.write(self.velocity.tostring())
      _x = self.speed_accuracy
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time is None:
        self.time = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.fix, _x.time.secs, _x.time.nsecs,) = _get_struct_B2I().unpack(str[start:end])
      start = end
      end += 24
      self.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      _x = self
      start = end
      end += 16
      (_x.horizontal_accuracy, _x.vertical_accuracy,) = _get_struct_2d().unpack(str[start:end])
      start = end
      end += 24
      self.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 8
      (self.speed_accuracy,) = _get_struct_d().unpack(str[start:end])
      self.time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_B2I = None
def _get_struct_B2I():
    global _struct_B2I
    if _struct_B2I is None:
        _struct_B2I = struct.Struct("<B2I")
    return _struct_B2I
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
